SetFactory("OpenCASCADE");
h = 0.2;
Point(1) = {-2, -2, 0, h};
Point(2) = {2, -2, 0, h};
Point(3) = {2, 2, 0, h};
Point(4) = {-2, 2, 0, h};
Point(5) = {-2, -2, -0.4, h};
Point(6) = {2, -2, -0.4, h};
Point(7) = {2, 2, -0.4, h};
Point(8) = {-2, 2, -0.4, h};
Point(9) = {-2, -2, -2, h};
Point(10) = {2, -2, -2, h};
Point(11) = {2, 2, -2, h};
Point(12) = {-2, 2, -2, h};
Point(13) = {-2, -2, -1.6, h};
Point(14) = {2, -2, -1.6, h};
Point(15) = {2, 2, -1.6, h};
Point(16) = {-2, 2, -1.6, h};
Point(17) = {-2, 2, -0.9, h};
Point(18) = {-2, -2, -0.8, h};
Point(19) = {2, -2, -0.7, h};
Point(20) = {2, 2, -0.8, h};
Point(21) = {0, 0, -0.8, h};
Point(22) = {0.4, 0, -0.8, h};
Point(24) = {0.4, -0.4, -0.8, h};
Point(25) = {0, -0.4, -0.8, h};
Point(26) = {-1, -1, -1.3, h};
Point(27) = {0.8, -0.8, -1.2, h};
Point(29) = {-0.5, 0.3, -1.2, h};
Point(31) = {0.9, 0.2, -1.1, h};
Line(1) = {3, 4};
Line(2) = {4, 1};
Line(3) = {1, 2};
Line(4) = {2, 3};
Line(5) = {7, 8};
Line(6) = {8, 5};
Line(7) = {5, 6};
Line(8) = {6, 7};
Line(9) = {20, 17};
Line(10) = {17, 18};
Line(11) = {18, 19};
Line(12) = {19, 20};
Line(13) = {15, 16};
Line(14) = {16, 13};
Line(15) = {13, 14};
Line(16) = {14, 15};
Line(17) = {11, 12};
Line(18) = {12, 9};
Line(19) = {9, 10};
Line(20) = {10, 11};
Line(21) = {3, 7};
Line(22) = {7, 20};
Line(23) = {20, 15};
Line(24) = {15, 11};
Line(25) = {4, 8};
Line(26) = {8, 17};
Line(27) = {17, 16};
Line(28) = {16, 12};
Line(29) = {1, 5};
Line(30) = {5, 18};
Line(31) = {18, 13};
Line(32) = {13, 9};
Line(33) = {2, 6};
Line(34) = {6, 19};
Line(35) = {19, 14};
Line(36) = {14, 10};
Line(37) = {22, 21};
Line(38) = {21, 25};
Line(39) = {25, 24};
Line(40) = {24, 22};
Line(41) = {21, 29};
Line(42) = {24, 27};
Spline(43) = {29, 31, 27};
Spline(44) = {27, 26, 29};
Line(45) = {17, 29};
Line(46) = {19, 27};

Line Loop(1) = {3, 4, 1, 2};
Plane Surface(1) = {1};
Line Loop(2) = {8, 5, 6, 7};
Plane Surface(2) = {2};
Line Loop(3) = {1, 25, -5, -21};
Plane Surface(3) = {3};
Line Loop(4) = {2, 29, -6, -25};
Plane Surface(4) = {4};
Line Loop(5) = {3, 33, -7, -29};
Plane Surface(5) = {5};
Line Loop(6) = {4, 21, -8, -33};
Plane Surface(6) = {6};
Surface Loop(1) = {1, 5, 6, 3, 4, 2};
Line Loop(7) = {5, 26, -9, -22};
Plane Surface(7) = {7};
Line Loop(8) = {6, 30, -10, -26};
Plane Surface(8) = {8};
Line Loop(9) = {7, 34, -11, -30};
Plane Surface(9) = {9};
Line Loop(10) = {8, 22, -12, -34};
Plane Surface(10) = {10};
Line Loop(11) = {37, 38, 39, 40};
Plane Surface(11) = {11};
Line Loop(12) = {43, -42, 40, 37, 41};
Surface(12) = {12};
Line Loop(14) = {38, 39, 42, 44, -41};
Surface(13) = {14};
Line Loop(16) = {9, 45, 43, -46, 12};
Surface(14) = {16};
Line Loop(18) = {45, -44, -46, -11, -10};
Surface(15) = {18};
Line Loop(20) = {27, 14, -31, -10};
Plane Surface(16) = {20};
Line Loop(21) = {13, 14, 15, 16};
Plane Surface(17) = {21};
Line Loop(22) = {23, -16, -35, 12};
Plane Surface(18) = {22};
Line Loop(23) = {27, -13, -23, 9};
Plane Surface(19) = {23};
Line Loop(24) = {43, 44};
Surface(20) = {24};
Line Loop(26) = {11, 35, -15, -31};
Plane Surface(21) = {26};
Line Loop(27) = {15, 36, -19, -32};
Plane Surface(22) = {27};
Line Loop(28) = {14, 32, -18, -28};
Plane Surface(23) = {28};
Line Loop(29) = {13, 28, -17, -24};
Plane Surface(24) = {29};
Line Loop(30) = {16, 24, -20, -36};
Plane Surface(25) = {30};
Line Loop(31) = {20, 17, 18, 19};
Plane Surface(26) = {31};
Surface Loop(2) = {26, 25, 24, 23, 22, 17};
Volume(1) = {2};
Surface Loop(3) = {19, 16, 21, 18, 17, 15, 14, 20};
Volume(2) = {3};
Surface Loop(4) = {11, 12, 13, 20};
Volume(3) = {4};
Surface Loop(5) = {2, 7, 8, 9, 10, 14, 15, 12, 13, 11};
Volume(4) = {5};
Surface Loop(6) = {1, 5, 6, 3, 4, 2};
Volume(5) = {6};
